Index: /extensions/Picasa2Piwigo/Picasa2Piwigo/StatusForm.cs
===================================================================
--- /extensions/Picasa2Piwigo/Picasa2Piwigo/StatusForm.cs	(revision 30535)
+++ /extensions/Picasa2Piwigo/Picasa2Piwigo/StatusForm.cs	(revision 30536)
@@ -77,5 +77,5 @@
             {
                 case constants.COMMAND_START_UP:
-                    WriteLog("Start up");
+                    logit.WriteLog("Start up");
 
                     //1.  Reading Picasa contacts
@@ -91,4 +91,5 @@
                     }
 
+                    logit.WriteLog("Read picasa contacts");    
                     //2.  Validate that server can be reached                   
                     SetStatus(WinFormStrings.CheckServerConnStrRes);
@@ -104,4 +105,5 @@
 
                     //3.  Login                    
+                    logit.WriteLog("logging in");    
                     SetStatus(WinFormStrings.LogInStrRes);
                     step_passed = UpdateStatus(SyncPiwigoLogIn());
@@ -117,4 +119,5 @@
                     //4.  Get Piwigo Version
                     PiwigoVersionNumber = "";
+                    logit.WriteLog("getting version number from piwigo");    
                     SetStatus(WinFormStrings.GetPiwigoVersionStrRes);
                     step_passed = UpdateStatus(SyncPiwigoGetVersion(ref PiwigoVersionNumber));
@@ -126,4 +129,5 @@
 
                     //5.  Get list of albums
+                    logit.WriteLog("getting list of albums from piwigo");    
                     SetStatus(WinFormStrings.RetrieveAlbumListStRes);
                     step_passed = UpdateStatus(SyncPiwigoGetAlbums(ref AlbumList));
@@ -140,5 +144,5 @@
 
                 case constants.COMMAND_ADD_TO_ALBUM:
-                    WriteLog("Add to Album");
+                    logit.WriteLog("Add to Album");
 
                     //1.  Validate that server can be reached
@@ -182,5 +186,5 @@
 
                 case constants.COMMAND_NEW_ALBUM:
-                    WriteLog("New Album");
+                    logit.WriteLog("New Album");
 
                     //1.  Validate that server can be reached
@@ -482,8 +486,8 @@
                 0x70, 0x74, 0x69, 0x6F, 0x6E, 0x20, 0x6D, 0x77, 0x67, 0x2D, 0x72, 0x73, 0x3A, 
                 0x4E, 0x61, 0x6D, 0x65, 0x3D, 0x22 };
-            int temp1, temp2, k, i, m;
+            int temp1, temp2, k, l, i, m, LengthToConvert;
             UInt16 signature, exif_length;
             string name_from_photo, tempstr;
-            byte[] temp_array = new byte[1];
+            byte[] temp_array = new byte[4];
 
             try
@@ -517,32 +521,58 @@
                         {
                             name_from_photo = "";
-                            do
+                            //found a name
+                            if (k >= exif_length - 5)
                             {
-                                //found a name
-                                temp_array[0] = filedata[k];
-                                tempstr = Encoding.Default.GetString(temp_array);
-                                if (tempstr != "\"")
+                                //just in case we're trying to read beyond end of filedata
+                                //probably will never happen
+                                logit.WriteLog("Read to end of xml");
+                                break;
+                            }
+                            temp_array[0] = filedata[k];
+                            temp_array[1] = filedata[k + 1];
+                            temp_array[2] = filedata[k + 2];
+                            temp_array[3] = filedata[k + 3];
+                            //tempstr = Encoding.UTF8.GetString(filedata);
+                            if (exif_length - k > 1024)
+                            {
+                                LengthToConvert = 1024;
+                            }
+                            else
+                            {
+                                LengthToConvert = exif_length - k;
+                            }
+                            if (LengthToConvert < 3)
+                            {
+                                logit.WriteLog("Too close to end of xml");
+                                break;
+                            }
+                            tempstr = Encoding.UTF8.GetString(filedata, k, LengthToConvert);
+                            l = tempstr.IndexOf("\"");
+                            if (l != -1)
+                            {
+                                tempstr = tempstr.Substring(0, l);
+                                k += tempstr.Length;
+                                name_from_photo = tempstr;
+
+                                if (name_from_photo.Substring(0, 1) == "0")
                                 {
-                                    name_from_photo += tempstr;
+                                    name_from_photo = name_from_photo.Substring(1);
                                 }
-                                else
+                                //have name, search for it in array
+                                for (i = 0; i < person_count; i++)
                                 {
-                                    if (name_from_photo.Substring(0, 1) == "0")
+                                    if (name_from_photo == contact_array[i].name)
                                     {
-                                        name_from_photo = name_from_photo.Substring(1);
+                                        found_contact_in_photo_array[i] = true;
+                                        break;
                                     }
-                                    //have name, search for it in array
-                                    for (i = 0; i < person_count; i++)
-                                    {
-                                        if (name_from_photo == contact_array[i].name)
-                                        {
-                                            found_contact_in_photo_array[i] = true;
-                                            break;
-                                        }
-                                    }
-                                    break;
                                 }
-                                k++;
-                            } while (tempstr != "\"");
+                            }
+                            else
+                            {
+                                //couldn't find end of name, abort
+                                logit.WriteLog("couldn't find end of name: " + tempstr);
+                                break;
+                            }
                         }
                         k++;
@@ -603,5 +633,5 @@
             string filepath, inidata, photofilename, photo_file_name, ini_unique_id;
             string face_tag_list;
-            bool[] found_contact_in_photo_array = new bool[256];
+            bool[] found_contact_in_photo_array = new bool[Picasa2PiwigoConstants.constants.MAX_NUMBER_OF_CONTACTS];
             bool found_photo;
             bool finished_faces, found_person;
@@ -616,11 +646,5 @@
 
             //if it's a video file then skip it
-            if (photofilename.ToLower().IndexOf(".jpg", StringComparison.OrdinalIgnoreCase) == -1 &&
-                  photofilename.ToLower().IndexOf(".gif", StringComparison.OrdinalIgnoreCase) == -1 &&
-                  photofilename.ToLower().IndexOf(".png", StringComparison.OrdinalIgnoreCase) == -1 &&
-                  photofilename.ToLower().IndexOf(".tga", StringComparison.OrdinalIgnoreCase) == -1 &&
-                  photofilename.ToLower().IndexOf(".tif", StringComparison.OrdinalIgnoreCase) == -1 &&
-                  photofilename.ToLower().IndexOf(".tiff", StringComparison.OrdinalIgnoreCase) == -1 &&
-                  photofilename.ToLower().IndexOf(".psd", StringComparison.OrdinalIgnoreCase) == -1)
+            if (!CheckFileNameExtension(photofilename.ToLower()))
             {
                 return face_tag_list;
@@ -636,5 +660,5 @@
             {
                 if (found_contact_in_photo_array[k])
-                {                    
+                {
                     face_tag_list += RemoveCommaFromContract(GlobalClass.contact_array[k].name) + ",";
                 }
@@ -644,4 +668,5 @@
             if (File.Exists(filepath + "\\.picasa.ini"))
             {
+                logit.WriteLog("picasa.ini file exists");
                 try
                 {
@@ -659,4 +684,5 @@
             else if (File.Exists(filepath + "\\Picasa.ini"))
             {
+                logit.WriteLog("Picasa.ini file exists");
                 try
                 {
@@ -678,5 +704,5 @@
             {
                 while ((inidata = inifile.ReadLine()) != null)
-                {
+                {                    
                     if (inidata.Length > 4)
                     {
@@ -684,5 +710,5 @@
                         {
                             found_photo = false;
-                            k = inidata.IndexOf("]");
+                            k = inidata.IndexOf("]");                            
                             if (k != -1)
                             {
@@ -694,11 +720,5 @@
                             }
 
-                            if (photo_file_name.ToLower().IndexOf(".jpg", StringComparison.OrdinalIgnoreCase) != -1 ||
-                                photo_file_name.ToLower().IndexOf(".gif", StringComparison.OrdinalIgnoreCase) != -1 ||
-                                photo_file_name.ToLower().IndexOf(".png", StringComparison.OrdinalIgnoreCase) != -1 ||
-                                photo_file_name.ToLower().IndexOf(".tga", StringComparison.OrdinalIgnoreCase) != -1 ||
-                                photo_file_name.ToLower().IndexOf(".tif", StringComparison.OrdinalIgnoreCase) != -1 ||
-                                photo_file_name.ToLower().IndexOf(".tiff", StringComparison.OrdinalIgnoreCase) != -1 ||
-                                photo_file_name.ToLower().IndexOf(".psd", StringComparison.OrdinalIgnoreCase) != -1)
+                            if (CheckFileNameExtension(photo_file_name.ToLower()))
                             {
                                 found_photo = true;
@@ -746,4 +766,5 @@
                                             {
                                                 face_tag_list += GlobalClass.contact_array[l].name + ",";
+                                                logit.WriteLog("face_tag_list:  " + face_tag_list);
                                             }
                                         }
@@ -763,4 +784,5 @@
             if (face_tag_list.Length > 1)
             {
+                logit.WriteLog("end face_tag_list:  " + face_tag_list);
                 face_tag_list = face_tag_list.Substring(0, face_tag_list.Length - 1);
             }
@@ -820,4 +842,9 @@
                         GlobalClass.picasa_unique_id_arrary[GlobalClass.unique_id_count].index = GlobalClass.person_count;
                         GlobalClass.person_count++;
+                        if (GlobalClass.person_count >= constants.MAX_NUMBER_OF_CONTACTS)
+                        {
+                            GlobalClass.StatusDialogErrorMessage = WinFormStrings.TooManyPeopleTags;
+                            return false;    
+                        }
                     }
                     else
@@ -837,8 +864,8 @@
 
             WebRequest = FormSettings.Default.PiwigoUrlSetting + "/ws.php?method=pwg.session.getStatus";
-            WriteLog(WebRequest);
+            logit.WriteLog(WebRequest);
 
             WebResponse = SendWebGet(WebRequest);
-            WriteLog(WebResponse);
+            logit.WriteLog(WebResponse);
 
             if (WebResponse.IndexOf("An error occurred:") != -1)
@@ -865,16 +892,16 @@
             WebRequest = FormSettings.Default.PiwigoUrlSetting + "/ws.php?method=pwg.session.login";            
             PostData = "username=" + FormSettings.Default.PiwigoUserName + "&password=" + FormSettings.Default.PiwigoPassword;
-            WriteLog(WebRequest);
-            WriteLog(PostData);
+            logit.WriteLog(WebRequest);
+            logit.WriteLog("username=" + FormSettings.Default.PiwigoUserName + "&password=" + "*****");
             response = SendWebPost(WebRequest, PostData, "application/x-www-form-urlencoded");            
             if (!response)
             {
-                WriteLog("Log In Post Fail.");
+                logit.WriteLog("Log In Post Fail.");
                 return false;
             }
             WebRequest = FormSettings.Default.PiwigoUrlSetting + "/ws.php?method=pwg.session.getStatus";
-            WriteLog(WebRequest);
+            logit.WriteLog(WebRequest);
             WebResponse = SendWebGet(WebRequest);
-            WriteLog(WebResponse);
+            logit.WriteLog(WebResponse);
             if (WebResponse.IndexOf("An error occurred:") != -1)
             {
@@ -896,8 +923,8 @@
 
             WebRequest = FormSettings.Default.PiwigoUrlSetting + "/ws.php?method=pwg.getVersion";
-            WriteLog(WebRequest);
+            logit.WriteLog(WebRequest);
 
             WebResponse = SendWebGet(WebRequest);
-            WriteLog(WebResponse);
+            logit.WriteLog(WebResponse);
 
             PiwigoVersionNumber = "";
@@ -935,8 +962,8 @@
             }
 
-            WriteLog(WebRequest);
+            logit.WriteLog(WebRequest);
 
             WebResponse = SendWebGet(WebRequest);
-            WriteLog(WebResponse);
+            logit.WriteLog(WebResponse);
 
             if (WebResponse.IndexOf("An error occurred:") != -1)
@@ -959,8 +986,8 @@
 
             WebRequest = FormSettings.Default.PiwigoUrlSetting + "/ws.php?method=pwg.tags.getList";
-            WriteLog(WebRequest);
+            logit.WriteLog(WebRequest);
 
             WebResponse = SendWebGet(WebRequest);
-            WriteLog(WebResponse);
+            logit.WriteLog(WebResponse);
 
             if (WebResponse.IndexOf("An error occurred:") != -1)
@@ -1004,8 +1031,8 @@
             }
 
-            WriteLog(WebRequest);
+            logit.WriteLog(WebRequest);
 
             WebResponse = SendWebGet(WebRequest);
-            WriteLog(WebResponse);
+            logit.WriteLog(WebResponse);
 
             if (WebResponse.IndexOf("An error occurred:") != -1)
@@ -1030,5 +1057,5 @@
             string [] file_to_send = {local_command_line_args[0]};
             string[,] post_array = new string[10,2];
-            string image_id;
+            string image_id, filtered_xml;
             bool upload_failed, response;
             string face_tag_list, tag_list, comment_list, all_tags;
@@ -1044,76 +1071,91 @@
                 SetStatus(WinFormStrings.UploadingPHotoStrRes + " " + (i + 1).ToString() + " " + WinFormStrings.ofStrREf + " " + local_command_line_args.Length.ToString() + "...");
 
-                face_tag_list = SyncPiwigoGetFaceTags(local_command_line_args[i]);
-
-                tag_list = "";
-                comment_list = "";
-                all_tags = "";
-                SyncPiwigoGetTagsandComments(ref tag_list, ref comment_list, local_command_line_args[i]);
-
-                if (face_tag_list.Length != 0)
-                {
-                    all_tags = face_tag_list;
-                }
-                if (tag_list.Length != 0)
-                {
-                    if (all_tags.Length != 0)
-                    {
-                        all_tags += ",";
-                    }
-                    all_tags += tag_list;
-                }
-
                 k = local_command_line_args[i].LastIndexOf("\\");
                 filename = local_command_line_args[i].Substring(k + 1);
-                PhotoFileContents = FileToByteArray(local_command_line_args[i]);
-
-                WebRequest = FormSettings.Default.PiwigoUrlSetting + "/ws.php?method=pwg.images.addSimple";
-
-                WebResponse = "";
-                local_command_line_args[i] = local_command_line_args[i].Replace("\\","\\\\");
-                post_array[0, 0] = "name=\"category\"";
-                post_array[0, 1] = NewPiwigoAlbumId.ToString();
-                post_array[1, 0] = "name=\"name\"" ;
-                post_array[1, 1] = filename;
-                k = 2;
-                if (all_tags.Length != 0)
-                {                    
-                    post_array[k, 0] = "name=\"tags\"";
-                    post_array[k, 1] = all_tags;
-                    k++;
-                }
-                if (comment_list.Length != 0)
-                {
-                    post_array[k, 0] = "name=\"comment\"";
-                    post_array[k, 1] = "\"" + comment_list + "\"";
-                    k++;
-                }
-                post_array[k, 0] = "name=\"image\"" + ";filename=" + "\"" + local_command_line_args[i] + "\"";
-
-                WriteLog(WebRequest);
-                for (di = 0; di < k; di++)
-                {
-                    WriteLog(post_array[k, 0] + post_array[k, 1]);                    
-                }
-                
-
-                response = SendWebPostMultipart(WebRequest, post_array, "multipart/form-data", PhotoFileContents,
-                    ref WebResponse);
-
-                WriteLog(WebResponse);
-
-                if (!response)
-                {
-                    return false;
-                }
-                xmlResponse = XmlGetAttribute(FilterForXML(WebResponse), "stat");
-                if (xmlResponse == "ok")
-                {
-                    image_id = XmlGetElement(FilterForXML(WebResponse), "image_id");
-                }
-                else
-                {
-                    upload_failed = true;
-                }                
+                if (CheckFileNameExtension(filename.ToLower()))
+                {
+                    face_tag_list = SyncPiwigoGetFaceTags(local_command_line_args[i]);
+
+                    tag_list = "";
+                    comment_list = "";
+                    all_tags = "";
+                    SyncPiwigoGetTagsandComments(ref tag_list, ref comment_list, local_command_line_args[i]);
+
+                    if (face_tag_list.Length != 0)
+                    {
+                        all_tags = face_tag_list;
+                    }
+                    if (tag_list.Length != 0)
+                    {
+                        if (all_tags.Length != 0)
+                        {
+                            all_tags += ",";
+                        }
+                        all_tags += tag_list;
+                    }
+
+                    k = local_command_line_args[i].LastIndexOf("\\");
+                    filename = local_command_line_args[i].Substring(k + 1);
+                    PhotoFileContents = FileToByteArray(local_command_line_args[i]);
+
+                    WebRequest = FormSettings.Default.PiwigoUrlSetting + "/ws.php?method=pwg.images.addSimple";
+
+                    WebResponse = "";
+                    local_command_line_args[i] = local_command_line_args[i].Replace("\\", "\\\\");
+                    post_array[0, 0] = "name=\"category\"";
+                    post_array[0, 1] = NewPiwigoAlbumId.ToString();
+                    post_array[1, 0] = "name=\"name\"";
+                    post_array[1, 1] = filename;
+                    k = 2;
+                    if (all_tags.Length != 0)
+                    {
+                        post_array[k, 0] = "name=\"tags\"";
+                        post_array[k, 1] = all_tags;
+                        k++;
+                    }
+                    if (comment_list.Length != 0)
+                    {
+                        post_array[k, 0] = "name=\"comment\"";
+                        post_array[k, 1] = "\"" + comment_list + "\"";
+                        k++;
+                    }
+                    post_array[k, 0] = "name=\"image\"" + ";filename=" + "\"" + local_command_line_args[i] + "\"";
+
+                    logit.WriteLog(WebRequest);
+                    for (di = 0; di < k; di++)
+                    {
+                        logit.WriteLog(post_array[di, 0] + " " + post_array[di, 1]);
+                    }
+
+
+                    response = SendWebPostMultipart(WebRequest, post_array, "multipart/form-data", PhotoFileContents,
+                        ref WebResponse);
+
+                    logit.WriteLog(WebResponse);
+
+                    GlobalClass.StatusDialogErrorMessage = WinFormStrings.UploadUnableToUploadStrRes;                    
+
+                    if (!response)
+                    {
+                        return false;
+                    }
+
+                    filtered_xml = FilterForXML(WebResponse);
+                    if (filtered_xml.Length == 0)
+                    {                        
+                        logit.WriteLog("No xml response after upload.");
+                        return false;
+                    }
+
+                    xmlResponse = XmlGetAttribute(filtered_xml, "stat");
+                    if (xmlResponse == "ok")
+                    {
+                        image_id = XmlGetElement(FilterForXML(WebResponse), "image_id");
+                    }
+                    else
+                    {
+                        upload_failed = true;
+                    }
+                }
             }
             return !upload_failed;
@@ -1126,4 +1168,5 @@
             try
             {
+                ServicePointManager.Expect100Continue = false;
                 ServicePointManager.ServerCertificateValidationCallback = delegate { return true; };
                 ServicePointManager.SecurityProtocol = SecurityProtocolType.Ssl3;
@@ -1133,4 +1176,6 @@
                 request.Timeout = 60000;
                 request.Credentials = CredentialCache.DefaultCredentials;
+                request.Referer = "user-agent";
+                request.UserAgent = "Mozilla/5.0";
                 HttpWebResponse response = (HttpWebResponse)request.GetResponse();
 
@@ -1154,4 +1199,5 @@
             {
                 HttpWebRequest request = (HttpWebRequest)WebRequest.Create(webrequest);
+                ServicePointManager.Expect100Continue = false;
                 ServicePointManager.ServerCertificateValidationCallback = delegate { return true; };
                 ServicePointManager.SecurityProtocol = SecurityProtocolType.Ssl3;
@@ -1161,4 +1207,6 @@
                 request.Method = "POST";
                 request.Credentials = CredentialCache.DefaultCredentials;
+                request.Referer = "user-agent";
+                request.UserAgent = "Mozilla/5.0";
 
                 // Create POST data and convert it to a byte array.
@@ -1217,9 +1265,13 @@
         {
             XmlDocument StatusResponse = new XmlDocument();
-            StatusResponse.LoadXml(xmlstring);
-            XmlNodeList nodelist = StatusResponse.GetElementsByTagName(element);
-            foreach (XmlNode anode in nodelist)
-            {
-                return anode.ChildNodes[0].Value;
+
+            if (xmlstring.Length != 0)
+            {
+                StatusResponse.LoadXml(xmlstring);
+                XmlNodeList nodelist = StatusResponse.GetElementsByTagName(element);
+                foreach (XmlNode anode in nodelist)
+                {
+                    return anode.ChildNodes[0].Value;
+                }
             }
             return "";
@@ -1284,4 +1336,5 @@
         {
             int i;
+            ServicePointManager.Expect100Continue = false;
             ServicePointManager.ServerCertificateValidationCallback = delegate { return true; };
             ServicePointManager.SecurityProtocol = SecurityProtocolType.Ssl3;
@@ -1298,4 +1351,6 @@
             request.Credentials = CredentialCache.DefaultCredentials;
             request.KeepAlive = true;
+            request.Referer = "user-agent";
+            request.UserAgent = "Mozilla/5.0";
 
             try
@@ -1420,4 +1475,19 @@
             return true;
         }
+        public bool CheckFileNameExtension(string photofilename)
+        {
+            if (photofilename.IndexOf(".jpg", StringComparison.OrdinalIgnoreCase) == -1 &&
+                  photofilename.IndexOf(".jpeg", StringComparison.OrdinalIgnoreCase) == -1 &&
+                  photofilename.IndexOf(".gif", StringComparison.OrdinalIgnoreCase) == -1 &&
+                  photofilename.IndexOf(".png", StringComparison.OrdinalIgnoreCase) == -1 &&
+                  photofilename.IndexOf(".tga", StringComparison.OrdinalIgnoreCase) == -1 &&
+                  photofilename.IndexOf(".tif", StringComparison.OrdinalIgnoreCase) == -1 &&
+                  photofilename.IndexOf(".tiff", StringComparison.OrdinalIgnoreCase) == -1 &&
+                  photofilename.IndexOf(".psd", StringComparison.OrdinalIgnoreCase) == -1)
+            {
+                return false;
+            }
+            return true;
+        }
         public string FilterForXML(string input_xml)
         {
@@ -1433,42 +1503,7 @@
             else
             {
-                WriteLog("No xml found in string");
+                logit.WriteLog("No xml found in string");
             }
             return xml_only_str;
-        }
-        public void WriteLog(string logMessage)
-        {
-            string strLogFile;
-
-            strLogFile = "c:\\temp\\picasa2piwigo_log.txt";
-#pragma warning disable 0162
-            if (constants.DEBUG_LOG_ENABLED)            
-            {             
-                try
-                {
-#pragma warning restore 0162
-                    StreamWriter swLog;
-
-                    logMessage = string.Format("{0}: {1}", DateTime.Now, logMessage);
-
-                    if (!File.Exists(strLogFile))
-                    {
-                        swLog = new StreamWriter(strLogFile);
-                    }
-                    else
-                    {
-                        swLog = File.AppendText(strLogFile);
-                    }
-
-                    swLog.WriteLine(logMessage);
-                    swLog.WriteLine();
-
-                    swLog.Close(); 
-
-                }
-                catch
-                {
-                }
-            }
         }
     }
